#define _GNU_SOURCE
#include<sched.h>
#include "rasperf.h"
#include<stdio.h>
#include<unistd.h>
#include<stdlib.h>
#include<signal.h>
#define STACK_SIZE 4096

int pipe_fd[2], tid1, tid2;
char buffer[10];
int reader(void* arg);
int writer(void* arg);
int primary(void *arg)
{
	void *tid1_stack = malloc(STACK_SIZE);
	void *tid2_stack = malloc(STACK_SIZE);
	tid1 = clone(&writer, tid1_stack+STACK_SIZE,
			SIGCHLD|CLONE_SIGHAND|CLONE_FS|CLONE_VM|CLONE_FILES|CLONE_THREAD, NULL);
	tid2 = clone(&reader, tid2_stack+STACK_SIZE,
			SIGCHLD|CLONE_SIGHAND|CLONE_FS|CLONE_VM|CLONE_FILES|CLONE_THREAD, NULL); 
	return 0;
}
int reader(void* arg)
{
	read(pipe_fd[0], buffer, 1);
	return 0;
}
int writer(void* arg)
{
	write(pipe_fd[1], "a", 1);
	return 0;
}
int main(){

	unsigned int regr;
	time start, end;
	unsigned int avg;
	int status, i;
	void *child_stack = malloc(STACK_SIZE);
	int thread_pid;

	//asm volatile("mrc p15, 0, %0, c9, c14, 0" : "=r" (regr));
	//printf("regr: %x\n", regr);

	//initialize communication pipe
	for (i = 0; i < 1000; i++)
	{
		getTime(start);
		thread_pid = clone(&primary, child_stack+STACK_SIZE,
				SIGCHLD|CLONE_SIGHAND|CLONE_FS|CLONE_VM|CLONE_FILES|CLONE_THREAD, NULL);
		waitpid(thread_pid, 0, 0);
		getTime(end);
		printf("\nTime Taken %d", diff(end,start));
	}
	return 0; 
}
