#include <linux/module.h>
#include <linux/sched.h>

int init_module() 
{ 
	unsigned int regr;
	unsigned int i;
	unsigned int a, b;

	asm volatile("mrc p15, 0, %0, c9, c14, 0" : "=r" (regr));
	pr_info("User access regr: %x\n", regr);

	asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (a));
	i = current->pid;
	asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (b));

	pr_info("PID: %u, Time for getpid: %u\n", i, b - a);
	return 0; 
}

void cleanup_module()
{
}
