#define _GNU_SOURCE
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#define BLOCK_SIZE 4096

void main()
{
	char buffer[BLOCK_SIZE] __attribute__ ((__aligned__ (512)));
	struct timeval start, end;
	int fd=0;
	int i = 0;
	unsigned long long time;
	int child_status;
	char *fnames[] = {"file_1", "file_2", "file_3", "file_4", "file_5", "file_6",
		"file_7", "file_8", "file_9"};
	int numProcesses = 0;

label:
	numProcesses++;
	i = 0;
	printf("numProcesses: %d\n", numProcesses);
	while (i < numProcesses) {
		int pid = fork();
		if (pid == 0) {
			//printf("Opening %d %s\n", i, fnames[i]);
			fd = open(fnames[i], O_RDONLY|O_DIRECT);
			fflush(stdout);
			if (!fd) {
				printf("unable to open\n");
				exit(1);
			}
			gettimeofday(&start, NULL);
			while(1) {
				int rc = read(fd, buffer, BLOCK_SIZE);
				if (rc < 0) {
					perror("Read Error");
					exit(1);
				} else if(rc == 0)
					break;
			}
			gettimeofday(&end, NULL);
			lseek(fd, 0, SEEK_SET);
			time = (end.tv_sec*1e6+end.tv_usec) - (start.tv_sec*1e6+start.tv_usec);
			printf("time taken to read file # %d - %llu\n", i, time);
			sync();
			child_status = system("sudo /sbin/sysctl vm.drop_caches=3");
			sync();
			exit(0);
		}
		i++;
	}
	sleep(10);
	wait(&child_status);
	if (numProcesses < 9)
		goto label;
}
